<?php

namespace Tests\Services\OrderService\GetUpdateOrderModelByWMSOrderHeadersTest;

use App\Logistic;
use App\Owner;
use App\Services\LogisticService;
use App\Services\OracleDOCOrderHeaderService;
use App\Services\OrderService;
use App\Services\OwnerService;
use App\Services\ShopService;
use App\Services\WarehouseService;
use App\Shop;
use App\Warehouse;
use Carbon\Carbon;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Illuminate\Support\Str;
use Tests\TestCase;

class GetUpdateModelByWmsOrderHeadersTest extends TestCase
{
    /**
     * @var OrderService $service
     * @var OracleDOCOrderHeaderService $orderHeaderService
     */
    public $service;
    public $orderHeaderService;

    public function setUp(): void
    {
        parent::setUp();
        $this->service = app('OrderService');
        $this->orderHeaderService = app('OracleDocOrderHeaderService');
    }
    public function testExample()
    {
        $carbon =Carbon::now()->subHours(10);
        $date = '2020-09-18 18:13:50';
        $orderHeaders = $this->orderHeaderService->getWMSOrderOnStartDate($carbon);
        /**
         * @var OwnerService $ownerService
         * @var LogisticService $logisticService
         * @var ShopService $shopService
         * @var WarehouseService $warehouseService
         */
        $ownerService = app("OwnerService");
        $logisticService = app("LogisticService");
        $shopService = app('ShopService');
        $warehouseService = app('WarehouseService');

        $owners = $ownerService->getByWmsOrders($orderHeaders);
        $logistics = $logisticService->getByWmsOrders($orderHeaders);
        $shops = $shopService->getByWmsOrders($orderHeaders);
        $warehouses = $warehouseService->getByWmsOrders($orderHeaders);

        $orders = $this->service->getByWmsOrders($orderHeaders);
        $orders->each(function($item){
            $item->warehouse_id = rand(1,3);
            $item->owner_id = rand(1,50);
            $item->shop_id = rand(1,50);
            $item->logistic_id = rand(1,50);
            $item->consignee_name = Str::random(50);
            $item->consignee_phone = Str::random(50);
            $item->province = Str::random(50);
            $item->city = Str::random(50);
            $item->district = Str::random(50);
            $item->address = Str::random(50);
            $item->client_code = Str::random(52);
            $item->wms_edittime = Carbon::now();
            $item->wms_status = Str::random(10);
            $item->updated_at = Carbon::now();
            $item->created_at = Carbon::now();
        });
        $update_orders = $this->service->getUpdateOrderModelByWMSOrderHeaders($orderHeaders,$orders,$warehouses,$owners,$logistics,$shops);

        foreach ($orderHeaders as $orderHeader) {
            $order = $update_orders->where('code',$orderHeader->orderno)->first();
            $this->assertNotNull($order);

            $warehouse = Warehouse::query()->where('code',$orderHeader->warehouseid)->first();
            if($orderHeader->warehouseid ?? false)
                $this->assertEquals($warehouse->id ?? '',$order->warehouse_id ?? '');

            $owner = Owner::query()->where('code',$orderHeader->customerid)->first();
            if($orderHeader->customerid ?? false)
                $this->assertEquals($order->owner_id ?? '',$owner->id??'');

            $logistic = Logistic::query()->where('code',$orderHeader->userdefine1??'')->first();
            if($orderHeader->userdefine1 ?? false)
                $this->assertEquals($logistic->id ?? '',$logistic->id ?? '');
            $shop = Shop::query()->where('name',$orderHeader->issuepartyname)->where('owner_id',$owner->id)->first();
            if($orderHeader->issuepartyname ?? false)
                $this->assertEquals($shop->name,$orderHeader->issuepartyname);
            $this->assertEquals($order->consignee_name ,$orderHeader->c_contact);
            $this->assertEquals($order->consignee_phone ,empty($orderHeader->c_tel2)?$orderHeader->c_tel1:$orderHeader->c_tel2);
            $this->assertEquals($order->province ,$orderHeader->c_province);
            $this->assertEquals($order->city ,$orderHeader->c_city);
            $this->assertEquals($order->district ,$orderHeader->c_district);
            $this->assertEquals($order->client_code ,$orderHeader->soreference1);
            $this->assertEquals($order->wms_edittime ,(string)$orderHeader->edittime);
            $this->assertEquals($order->wms_status ,$orderHeader->oracleBASCode_codename_c);
            $this->assertEquals((string)$order->created_at ,(string)$orderHeader->addtime);
        }
    }
}
